package II194a7cf101873977c60fb0eb432ac85c::mod_ideal; use strict; use JSON::PP; use LWP::UserAgent; use HTTP::Request; use MIME::Base64 qw/encode_base64/; use IIcba56ff86952b27c841d7818e356d70e; use Digest::SHA qw(hmac_sha256_hex); use Digest::MD5 qw(md5_hex); use II48dee826ef8237129991b8a442e07452; use Data::Dumper; sub checkPGateSettings { my $class = shift; my $settings = shift; my @errors; push @errors, 'check.empty_api_credentials' unless $settings->{api_key}; eval { local $SIG{__DIE__} = 'DEFAULT'; require Crypt::SSLeay; }; push @errors, ['check.no_mod', 'Crypt::SSLeay'] if $@ && $ENV{HTTP_HOST} ne 'localhost'; @errors; } sub checkProductSettings { my $class = shift; my ($product) = @_; my @errors; @errors; } sub go { my $class = shift; my $pgtxn = shift; my $settings = $pgtxn->getPGateSettings; my $request = Zen->getRequest; my $in = $request->getInput; return ['go.no_bulk_payment'] unless $pgtxn->{sale_id}; my $pgate = $pgtxn->getPGate; my $sale = $pgtxn->getSale; my $order = $sale->getOrder; my $amount = int($sale->{amount}*100); my $digest = md5_hex("secret::PAID::word"); my $currency = $pgtxn->getCurrencyCode; _debug_log("REQ IBAN: " . $in->{user_iban}); my $data = { type => 'ideal', amount => $amount, currency => lc($currency), redirect => { return_url => $pgtxn->getFeedbackURL('return', 'pgt') . "?txn_id=" . $pgtxn->{id} . "&secret=" . $digest, }, owner => { email => $order->{user_email}, name => $order->{user_name}, } }; my $data_sepa = { type => 'sepa_debit', amount => $amount, currency => lc($currency), sepa_debit => { iban => $in->{user_iban}, }, redirect => { return_url => $pgtxn->getFeedbackURL('return', 'pgt') . "?txn_id=" . $pgtxn->{id} . "&secret=" . $digest, }, owner => { email => $order->{user_email}, name => $order->{user_name}, } }; my ($response, $error) = _send_request('API_SALE', $pgate, $sale, 'sources', length($in->{user_iban}) > 0 ? $data_sepa : $data); return [$response->{error}{message} . " Message: " . Dumper($response->{error}{messages})] if $response->{error}; if ($error) { if ($error->[0] eq 'go.internal_processing_error') { return; } else { return (undef, $error->[1]); } } $request->redirect($response->{redirect}{url}); } sub feedbackReturnPgt { my $in = Zen->getRequest->getInput; my $pgtxn_id = $in->{txn_id}; die "invalid txnid" unless $pgtxn_id; my $pgtxn = II4cbce4b2b36af61aad88a4dd7ed88dd7::lIIIIlIIIlllIIII($II493ffcbbcff34e82da42237dbf928223::lIllllllllIIIIII{$IId99543b965d34f74d97b5d9893026ec8::IIIIIIlIIlllIIlI},127,$II493ffcbbcff34e82da42237dbf928223::lIllllllllIIIIII{$II493ffcbbcff34e82da42237dbf928223::IIllIlIlIllllllI})->get($pgtxn_id); _debug_log("*** Stripe feedbackReturnPgt start"); $pgtxn->logg('RET', $in); $pgtxn->{txn_code} = "ideal-" . $in->{txn_id}; $pgtxn->{processed} = 1; my $pgate = $pgtxn->getPGate; my $sale = $pgtxn->getSale; my $order = $sale->getOrder; my $prod = $sale->getProduct; my $is_recur = $prod->isRecur; my $amount = int($sale->{amount}*100); my $currency = $pgtxn->getCurrencyCode; die "invalid secret" unless md5_hex("secret::PAID::word") eq $in->{secret}; my $data = { amount => $amount, currency => $currency, source => $in->{source}, receipt_email => $order->{user_email} }; if (!$is_recur){ _debug_log("*** Stripe feedbackReturnPgt not is_recur"); my ($response, $error) = _send_request('API_CHARGE', $pgate, $sale, 'charges', $data, 360); if ($error) { if ($error->[0] eq 'go.internal_processing_error') { return; } else { return (undef, $error->[1]); } } die "Not paid" unless $response->{paid}; } else { _debug_log("*** Stripe feedbackReturnPgt is_recur. USER_NAME: " . $order->{user_name}); my $subscr = II4cbce4b2b36af61aad88a4dd7ed88dd7::IlIIllllIllIllII($II4cbce4b2b36af61aad88a4dd7ed88dd7::lIlllIIlllllIlll{$II493ffcbbcff34e82da42237dbf928223::lIlIIIIlIlllllIl},172,$II4cbce4b2b36af61aad88a4dd7ed88dd7::lIlllIIlllllIlll{$IId99543b965d34f74d97b5d9893026ec8::llIIIIIIlIlIllII})->getOrCreateForSale($sale); $subscr->{refsale_next_ref_id} = $in->{txn_id}; $subscr->save; $sale->{subscr_id} = $subscr->{subscr_id}; if ($sale->{amount} > 0) { my ($response, $error) = _send_request('API_CHARGE', $pgate, $sale, 'charges', $data, 360); if ($error) { if ($error->[0] eq 'go.internal_processing_error') { return; } else { return (undef, $error->[1]); } } $sale->{txn_code} = $in->{txn_id}; } } $pgtxn->{successful} = 1; $sale->{paid} = 1; $sale->save; $pgtxn->save; _debug_log("*** Stripe feedbackReturnPgt redirectToReturnPage"); $pgtxn->redirectToReturnPage; } sub apiReferenceSale { my $class = shift; my ($pgate, $sale, $ref_id) = @_; my $settings = $pgate->getPGateSettings; my $order = $sale->getOrder; my $descr = $sale->{descr} . ($sale->{subscr_descr_more} ? " ($sale->{subscr_descr_more})" : ''); my $metadata = { sale_id => $sale->{id}, email => $order->{user_email}, origin => "Delavo at $ENV{HTTP_HOST}", }; my $data = { amount => int($sale->{amount} * 100), currency => lc(II4cbce4b2b36af61aad88a4dd7ed88dd7::lIIIIlIIIlllIIII($II4cbce4b2b36af61aad88a4dd7ed88dd7::llllIIllllllllll{$II4cbce4b2b36af61aad88a4dd7ed88dd7::IlllIlIIlIllllll},76,$II4cbce4b2b36af61aad88a4dd7ed88dd7::llllIIllllllllll{$II4cbce4b2b36af61aad88a4dd7ed88dd7::IlIllIlIIlIlllII})->getCurrCode), customer => $ref_id, description => $descr, metadata => $metadata, receipt_email => $order->{user_email}, }; my ($response, $error) = _send_request('APIREFSALE', $pgate, $sale, 'charges', $data, 360); if ($error) { if ($error->[0] eq 'go.internal_processing_error') { return; } else { return (undef, $error->[1]); } } $sale->{txn_code} = $response->{id}; $sale->{paid} = 1; $sale->save; $ref_id; } sub apiRefund { my $class = shift; my ($pgate, $sale, $amount) = @_; my $settings = $pgate->getPGateSettings; return 1 if $sale->{amount} == 0; my $data = {}; $data->{amount} = int($amount * 100) if $amount; my ($response, $error) = _send_request('APIREFUND', $pgate, $sale, "charges/$sale->{txn_code}/refunds", $data); if ($error) { if ($error->[0] ne 'go.internal_processing_error') { $pgate->paylog('APIREFUND_ERROR', $sale, $error->[1]); } return; } 1; } sub apiPartialRefundAllowed { 1 } sub _send_request { my ($paylog_label, $pgate, $sale, $command, $data, $timeout) = @_; my $settings = $pgate->getPGateSettings; my $timeout = $timeout ? $timeout : 180; my $api_url = "https://api.stripe.com/v1/$command"; my $formdata = _convert_to_formdata($data); $pgate->paylog($paylog_label . '_REQ', $sale, _prepare_paylog($formdata)); my $ua = LWP::UserAgent->new; $ua->timeout($timeout); $ua->env_proxy; my $cb_req_body = IId99543b965d34f74d97b5d9893026ec8::IlIlIIlllIlllIll($IIc7fecbd5fe35630f6f93276648a0da22::lllIlIllIIIllIll{$IId99543b965d34f74d97b5d9893026ec8::lllIlIIlIlIlllII},937,$IIc7fecbd5fe35630f6f93276648a0da22::lllIlIllIIIllIll{$IId99543b965d34f74d97b5d9893026ec8::llllIIIlIlIIlIlI})->URLPack($formdata); my $req = HTTP::Request->new('POST', $api_url); $req->header( Authorization => "Bearer " . $settings->{api_key}); $req->content_type('application/x-www-form-urlencoded'); $req->content($cb_req_body); _debug_log("*** Stripe Request: [\n" . $cb_req_body . "]"); my $res = $ua->request($req); _debug_log("*** Stripe Response: [\n" . Dumper($res) . "]"); if ($res->code == 200) { my $respdata = decode_json($res->content); return ($respdata); } elsif ($res->code == 500) { my $errmsg = $res->status_line . " - " . $res->content; $pgate->paylog($paylog_label . '_INTERR', $sale, $errmsg); return (undef, ['go.internal_processing_error', $errmsg]); } my @return = eval { my $hash = decode_json($res->content); return (undef, ['go.payment_failed', $hash->{error}{message}]); }; if ($@) { my $error = "Could not decode HTTP response: $@"; return (undef, ['go.internal_processing_error', "Could not decode HTTP response: $@"]); }; @return; } sub _convert_to_formdata { my $struct = shift; my $data = {}; my $process_value; $process_value = sub { my ($key, $value) = @_; if (ref($value) eq 'HASH') { while (my ($k, $v) = each %$value) { my $new_key = $key ? $key . "[$k]" : $k; &$process_value($new_key, $v); } } elsif (ref($value) eq 'ARRAY') { for (my $i = 0; $i < @$value; $i++) { &$process_value($key . "[$i]", $value->[$i]); } } else { $data->{$key} = $value; } }; &$process_value('', $struct); return $data; } sub _prepare_paylog { my $orig_data = shift; my $data = {%$orig_data}; for ("card[number]") { if (exists $data->{$_}) { $data->{$_} = ('*' x 12) . substr($data->{$_}, 12, 4); } } for ("card[cvc]") { if (exists $data->{$_}) { $data->{$_} = ('*' x (length($data->{$_}))); } } return $data; } sub _debug_log { my $orig_data = shift; my $dt = II493ffcbbcff34e82da42237dbf928223::llllIllIIIlIlIlI($II493ffcbbcff34e82da42237dbf928223::lIlIlllIIlIIlIII{$II4cbce4b2b36af61aad88a4dd7ed88dd7::IIllIlIlIIIllIIl},952,$II493ffcbbcff34e82da42237dbf928223::lIlIlllIIlIIlIII{$II493ffcbbcff34e82da42237dbf928223::IIllIlIlIllllllI})->new; if (open F, '>>' . Zen->getSitebox . 'ideal_new.pay.' . $dt->format('%Y-%m-%d') . '.log') { print F "[" . scalar(localtime) . "]\n"; print F "$orig_data\n"; close F; } } 1; 